//
// Written by Igor Tolmachev, IT Samples
//        mailto:support@itsamples.com
//
// Copyright (c) 2009.
//
// This code may be used in compiled form in any way you desire. This
// file may be redistributed unmodified by any means PROVIDING it is 
// not sold for profit without the authors written consent, and 
// providing that this notice and the authors name and all copyright 
// notices remains intact. If the source code in this file is used in 
// any  commercial application then a statement along the lines of 
// "Portions copyright (c) Igor Tolmachev, 2009" must be included in 
// the startup banner, "About" box or printed documentation. An email 
// letting me know that you are using it would be nice as well. That's 
// not much to ask considering the amount of work that went into this.
//
// This file is provided "as is" with no expressed or implied warranty.
// The author accepts no liability for any damage/loss of business that
// this product may cause.
//
// Expect bugs!
// 
// Please use and enjoy, and let me know of any bugs/mods/improvements 
// that you have found/implemented and I will fix/incorporate them into 
// this file. 

// RDPStorage.h: interface for the CRDPStorage class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RDPSTORAGE_H__2455A545_4B73_46DF_9F11_8F5ADF2A6D41__INCLUDED_)
#define AFX_RDPSTORAGE_H__2455A545_4B73_46DF_9F11_8F5ADF2A6D41__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <wincred.h>
#include <wincrypt.h>
#include <afxtempl.h>

#define WM_POSTLASTMESSAGE WM_USER+99

#pragma comment(lib, "Crypt32.lib")

class CRDPStorage  
{
public:
	void SetMessageTarget(HWND hWnd);
	BOOL LoadFromFile(char* pszPath);

	CRDPStorage();
	virtual ~CRDPStorage();

protected:
	void PostLastMessage(char* pszMessage);
	int Decrypt(char* pszData);
	void Hex2Blob(char* pszIn, DATA_BLOB* blobOut);
	
protected:
	HWND m_hWndParent;
};

#endif // !defined(AFX_RDPSTORAGE_H__2455A545_4B73_46DF_9F11_8F5ADF2A6D41__INCLUDED_)
